include $(TOP)/config/before.mk

# Win32 (Cygwin-32)
#

CXX = clwrapper -gnuwin32
CXXLINK = linkwrapper -gnuwin32
AR = libwrapper -gnuwin32
CP = cp
MKDIRHIER = mkdir -p
BinPattern = %.exe
LibPattern = %.lib

INSTALL         = install -c
INSTLIBFLAGS    = -m 0644
INSTEXEFLAGS    = -m 0755

%.o: %.c
	$(CC) -c $(CFLAGS) -Fo./$@ $<

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -Fo./$@ $<

%.o: $(SRC_DIR)/%.cc
	$(CXX) -c $(CXXFLAGS) -Fo./$@ $<

# OmniORB
BUILD_NAME = omniORB_260_nt40

LIB_DIR = $(TOP)/lib/$(BUILD_NAME)
BIN_DIR = $(TOP)/bin/$(BUILD_NAME)


CORBA_IMPL_ROOT = d:/corba/omniORB_2.6.1
CORBA_INCLUDE_DIR = -I$(CORBA_IMPL_ROOT)/include \
 -I$(CORBA_IMPL_ROOT)/src/lib/omniORB2 -I../../../../stl
IDL_COMPILER  = $(CORBA_IMPL_ROOT)/bin/x86_win32/omniidl2.exe
CXXMAKEDEPEND = $(CORBA_IMPL_ROOT)/bin/x86_win32/omkdepend -D__cplusplus -D_MSC_VER
CORBA_LIBDIR = $(CORBA_IMPL_ROOT)/lib/x86_win32
CORBA_LIB = omniORB260_rt.lib omnithread2_rt.lib ws2_32.lib advapi32.lib
CORBA_CXX_FLAGS = -GX -nologo -DXSTD=std
CORBA_CXX_DEFINES = -D__x86__ -D__NT__ -D__OSVERSION__=4 -D__WIN32__ -DOMNIORB
IDL_DEFINES= -DOMNIORB
STUB_HDR_SUBST = $(STUB_DIR)/%.hh
STUB_SRC_SUBST = $(STUB_DIR)/%SK.cc
STUB_OBJ_SUBST = $(STUB_DIR)/%SK.o
IDLFLAGS = -I$(TOP)/idl -h.hh -sSK.cc -a

IMPORT_LIBRARY_FLAGS = $(patsubst %,-libpath:%/$(LIBDIR),$(IMPORT_TREES))

define CXXExecutable
(set -x; \
 $(RM) $@; \
 x=""; \
 for i in $$libs ; do \
  x="$$x $(patsubst %,$(LibPattern),$$i)"; \
 done; \
 $(CXXLINK) -out:$@ $(CXXLINKOPTIONS) -libpath:$(CORBA_LIBDIR) -libpath:$(LIB_DIR) $^ $(CORBA_LIB)  $$x; \
)
endef

define StaticLinkLibrary
(set -x; \
 $(RM) $@; \
 $(AR) $@ $^; \
)
endef

define InstallLibrary
(dir="$(LIB_DIR)"; \
 files="$^"; \
 for file in $$files; do \
   $(InstallFile); \
 done; \
)
endef

include $(TOP)/config/rest.mk
include $(SRC_DIR)/dir.mk
include $(TOP)/config/last.mk

