// $Id: OORB_DII.cc,v 1.3 1999/05/04 19:10:28 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/OORB_DII.cc,v $
//
// $Log: OORB_DII.cc,v $
// Revision 1.3  1999/05/04 19:10:28  mencnar
// Trace messages redirected to a trace object
//
// Revision 1.2  1999/02/24 12:05:02  mencnar
// *** empty log message ***
//
//

#include "echelp.hh"
#include "ec_dii.hh"
#include "trace.hh"

#ifdef OMNIORB
// omniORB specific file
//

#include <iostream.h>
#include <omniORB2/CORBA.h>
#include <tcParseEngine.h>
#include "compatibility.hh"

void oorb_fill( CORBA::ULong malign, MemBufferedStream &val);
void oorb_marshal( CORBA::Any &v, MemBufferedStream &nbs);

class OORB_DII : public EC_DII
{
  CORBA::Object *obj;
  omniObject *oimpl;
  ECHelper::TypedInterface ti;

  CORBA::ULong find_operation_index( const char *name, const char *prefix);
public:
  OORB_DII( CORBA::Object *obj,
	    ECHelper::TypedInterface &_ti);  
  virtual void send ( const char *operation_name, 
		      ECHelper::SeqAny &params );

  virtual void send_pull( const char *operation_name, 
			  ECHelper::SeqAny &params);

  virtual CORBA::Boolean send_try_pull( const char *operation_name,
					ECHelper::SeqAny &params);
};


OORB_DII::
OORB_DII( CORBA::Object *an_obj,
	  ECHelper::TypedInterface &_ti) :
  obj( an_obj),
  ti( _ti),
  oimpl( an_obj->PR_getobj())
{
  // PRECONDITION: an_obj != NULL
}

void oorb_fill( CORBA::ULong malign, MemBufferedStream &val) {
  CORBA::Char* filler = new CORBA::Char[malign];
  try {
    val.put_char_array(filler,malign);
  }
  catch (...) {
    delete[] filler;
    throw;
  }
  delete[] filler;
}

void oorb_marshal( CORBA::Any &v, MemBufferedStream &nbs) {
  MemBufferedStream mbs;
  MemBufferedStream val;

  trace.start(800) << "<<marshal" << '\n';

  // set the number of written butes to "val" so it could match those
  // in "nbs" 
  //
  int malign= nbs.alreadyWritten() % 8;
  //  cerr << "malign " << malign << endl;
  oorb_fill( malign, val);

  v >>= mbs;  // write CORBA::Any to MemBufferedStream
  //  cerr << "value marshalled to MBS" << endl;
  mbs.rewind_in_mkr();
  CORBA::TypeCode* tc= new CORBA::TypeCode(CORBA::tk_null,0);;
  *tc <<= mbs;  // get rid of TypeCode marshalled at the begining of the stream
  
  trace.start(800) << "tcParaseEngine" << '\n';
  tcParseEngine tcEngine(tc,&mbs);
  tcEngine.parse( val);
  trace.start(800) << "sent " << (long) val.alreadyWritten() - malign << '\n';
  nbs.put_char_array((_CORBA_Char*) (omni::ptr_arith_t) val.data() +
		     (omni::ptr_arith_t) malign, 
		     val.alreadyWritten() - malign);
  delete tc;
  trace.start(800) << ">>marshal" << '\n';
}

CORBA::ULong OORB_DII::
find_operation_index( const char *name, const char *prefix) {
  CORBA::String_var opname= 
    CORBA::string_alloc( strlen(name)+strlen(prefix)+1);
  strcpy(opname, prefix);
  strcat(opname, name);
  CORBA::ULong opi;
  for (opi=0; opi<ti.ops.length(); opi++)
    if (strcmp(opname,(const char *) ti.ops[opi].name) == 0) break;
  if (opi==ti.ops.length()) throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
  return opi;
}

void OORB_DII::
send ( const char *operation_name, ECHelper::SeqAny &params )
{
  CORBA::ULong opi= find_operation_index( operation_name,"");

  CORBA::ULong _0RL_retries = 0;
#ifndef EGCS_WORKAROUND
_0RL_again:
#else
while(1) {
#endif
  oimpl->assertObjectExistent();
  omniRopeAndKey _0RL_r;
  CORBA::Boolean _0RL_fwd = oimpl->getRopeAndKey(_0RL_r);
  CORBA::Boolean _0RL_reuse = 0;
  try {
    GIOP_C _0RL_c(_0RL_r.rope());
    _0RL_reuse = _0RL_c.isReUsingExistingConnection();
    CORBA::ULong malign = 
      (_0RL_c.WrMessageAlreadyWritten()+
      GIOP_C::RequestHeaderSize(_0RL_r.keysize(), strlen(operation_name)+1))
      % 8;

    MemBufferedStream mbs;
    oorb_fill( malign, mbs);
    for (int i=0; i<params.length(); i++)
      oorb_marshal( params[i], mbs);
    CORBA::ULong _0RL_msgsize= mbs.alreadyWritten()-malign+
      GIOP_C::RequestHeaderSize(_0RL_r.keysize(), strlen(operation_name)+1);
    trace.start(800) << "msgsize " << (int) _0RL_msgsize << '\n';
    
    _0RL_c.InitialiseRequest(_0RL_r.key(),
			     _0RL_r.keysize(),
			     (char *)operation_name,
			     strlen(operation_name)+1,_0RL_msgsize,
			     !ti.ops[opi].twoway);
    trace.start(800) << "request initialized" << '\n';
    _0RL_c.put_char_array((_CORBA_Char*) (omni::ptr_arith_t) mbs.data() +
			  (omni::ptr_arith_t) malign, 
			  mbs.alreadyWritten() - malign); 
    trace.start(800) << "paramters put into array" << '\n';

    switch (_0RL_c.ReceiveReply())
    {
      case GIOP::NO_EXCEPTION:
      {
        _0RL_c.RequestCompleted();
        return;
        break;
      }
      case GIOP::USER_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw CORBA::UNKNOWN(0,CORBA::COMPLETED_MAYBE);
        break;
      }
      case GIOP::SYSTEM_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw omniORB::fatalException(__FILE__,__LINE__,"GIOP::SYSTEM_EXCEPTION should not be returned by GIOP_C::ReceiveReply()");
      }
      case GIOP::LOCATION_FORWARD:
      {
        {
          CORBA::Object_var obj = CORBA::Object::unmarshalObjRef(_0RL_c);
          _0RL_c.RequestCompleted();
          if (CORBA::is_nil(obj)) {
            if (omniORB::traceLevel > 10) {
              omniORB::log << "Received GIOP::LOCATION_FORWARD message that contains a nil object reference.\n";
              omniORB::log.flush();
            }
            throw CORBA::COMM_FAILURE(0,CORBA::COMPLETED_NO);
          }
          omniRopeAndKey _0RL__r;
          obj->PR_getobj()->getRopeAndKey(_0RL__r);
          oimpl->setRopeAndKey(_0RL__r);
        }
        if (omniORB::traceLevel > 10) {
          omniORB::log << "GIOP::LOCATION_FORWARD: retry request.\n";
          omniORB::log.flush();
        }
        break;
      }
    }
  }
  catch (const CORBA::COMM_FAILURE& ex) {
    if (_0RL_reuse || _0RL_fwd) {
      if (_0RL_fwd)
        oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callCommFailureExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::TRANSIENT& ex) {
    if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (const CORBA::OBJECT_NOT_EXIST& ex) {
    if (_0RL_fwd) {
      oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::SystemException& ex) {
    //    cerr << (CORBA::Exception &) ex << endl;
    if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (...) {
    throw;
  }
#ifndef EGCS_WORKAROUND
  goto _0RL_again;
#else
}
#endif
}

void OORB_DII::
send_pull( const char *operation_name, ECHelper::SeqAny &params )
{
  CORBA::ULong opi= find_operation_index(operation_name,"pull_");

  CORBA::String_var my_opname= 
    CORBA::string_alloc( strlen(operation_name)+strlen("pull_")+1);
  strcpy( my_opname, "pull_");
  strcat( my_opname, operation_name);

  CORBA::ULong _0RL_retries = 0;
#ifndef EGCS_WORKAROUND
_0RL_again:
#else
while(1) {
#endif
  oimpl->assertObjectExistent();
  omniRopeAndKey _0RL_r;
  CORBA::Boolean _0RL_fwd = oimpl->getRopeAndKey(_0RL_r);
  CORBA::Boolean _0RL_reuse = 0;
  try {
    GIOP_C _0RL_c(_0RL_r.rope());
    _0RL_reuse = _0RL_c.isReUsingExistingConnection();
    CORBA::ULong _0RL_msgsize= GIOP_C::RequestHeaderSize(_0RL_r.keysize(), 
							 strlen(my_opname)+1);
    _0RL_c.InitialiseRequest(_0RL_r.key(),
			     _0RL_r.keysize(),
			     (char *) my_opname,
			     strlen(my_opname)+1,_0RL_msgsize,0);
    trace.start(800) << "request initialized" << '\n';

    switch (_0RL_c.ReceiveReply())
    {
      case GIOP::NO_EXCEPTION:
      {
	params.length( ti.ops[opi].parameter_types.length());
	
	for (CORBA::ULong i=0; i<params.length(); i++) {
	  MemBufferedStream mbs;
	  ti.ops[opi].parameter_types[i] >>= mbs;
	  tcParseEngine tcEngine(ti.ops[opi].parameter_types[i],&_0RL_c);
	  tcEngine.parse( mbs);
	  CORBA::Any val;
	  params[i] <<= mbs;
	}
        _0RL_c.RequestCompleted();
        return;
        break;
      }
      case GIOP::USER_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw CORBA::UNKNOWN(0,CORBA::COMPLETED_MAYBE);
        break;
      }
      case GIOP::SYSTEM_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw omniORB::fatalException(__FILE__,__LINE__,"GIOP::SYSTEM_EXCEPTION should not be returned by GIOP_C::ReceiveReply()");
      }
      case GIOP::LOCATION_FORWARD:
      {
        {
          CORBA::Object_var obj = CORBA::Object::unmarshalObjRef(_0RL_c);
          _0RL_c.RequestCompleted();
          if (CORBA::is_nil(obj)) {
            if (omniORB::traceLevel > 10) {
              omniORB::log << "Received GIOP::LOCATION_FORWARD message that contains a nil object reference.\n";
              omniORB::log.flush();
            }
            throw CORBA::COMM_FAILURE(0,CORBA::COMPLETED_NO);
          }
          omniRopeAndKey _0RL__r;
          obj->PR_getobj()->getRopeAndKey(_0RL__r);
          oimpl->setRopeAndKey(_0RL__r);
        }
        if (omniORB::traceLevel > 10) {
          omniORB::log << "GIOP::LOCATION_FORWARD: retry request.\n";
          omniORB::log.flush();
        }
        break;
      }
    }
  }
  catch (const CORBA::COMM_FAILURE& ex) {
    if (_0RL_reuse || _0RL_fwd) {
      if (_0RL_fwd)
        oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callCommFailureExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::TRANSIENT& ex) {
    if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (const CORBA::OBJECT_NOT_EXIST& ex) {
    if (_0RL_fwd) {
      oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::SystemException& ex) {
    if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (...) {
    throw;
  }
#ifndef EGCS_WORKAROUND
  goto _0RL_again;
#else
}
#endif
}

CORBA::Boolean OORB_DII::
send_try_pull( const char *operation_name, ECHelper::SeqAny &params )
{
  CORBA::ULong opi= find_operation_index(operation_name,"try_");

  CORBA::String_var my_opname= 
    CORBA::string_alloc( strlen(operation_name)+strlen("try_")+1);
  strcpy( my_opname, "try_");
  strcat( my_opname, operation_name);

  CORBA::ULong _0RL_retries = 0;
#ifndef EGCS_WORKAROUND
_0RL_again:
#else
while(1) {
#endif
  oimpl->assertObjectExistent();
  omniRopeAndKey _0RL_r;
  CORBA::Boolean _0RL_fwd = oimpl->getRopeAndKey(_0RL_r);
  CORBA::Boolean _0RL_reuse = 0;
  try {
    GIOP_C _0RL_c(_0RL_r.rope());
    _0RL_reuse = _0RL_c.isReUsingExistingConnection();
    CORBA::ULong _0RL_msgsize= GIOP_C::RequestHeaderSize(_0RL_r.keysize(), 
							 strlen(my_opname)+1);
    _0RL_c.InitialiseRequest(_0RL_r.key(),
			     _0RL_r.keysize(),
			     (char *) my_opname,
			     strlen(my_opname)+1,_0RL_msgsize,0);
    trace.start(800) << "request initialized" << '\n';

    switch (_0RL_c.ReceiveReply())
    {
      case GIOP::NO_EXCEPTION:
      {
	params.length( ti.ops[opi].parameter_types.length());
	
	CORBA::Boolean ret;
	ret <<= _0RL_c;
	for (CORBA::ULong i=0; i<params.length(); i++) {
	  MemBufferedStream mbs;
	  ti.ops[opi].parameter_types[i] >>= mbs;
	  tcParseEngine tcEngine(ti.ops[opi].parameter_types[i],&_0RL_c);
	  tcEngine.parse( mbs);
	  CORBA::Any val;
	  params[i] <<= mbs;
	}
        _0RL_c.RequestCompleted();
        return ret;
        break;
      }
      case GIOP::USER_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw CORBA::UNKNOWN(0,CORBA::COMPLETED_MAYBE);
        break;
      }
      case GIOP::SYSTEM_EXCEPTION:
      {
        _0RL_c.RequestCompleted(1);
        throw omniORB::fatalException(__FILE__,__LINE__,"GIOP::SYSTEM_EXCEPTION should not be returned by GIOP_C::ReceiveReply()");
      }
      case GIOP::LOCATION_FORWARD:
      {
        {
          CORBA::Object_var obj = CORBA::Object::unmarshalObjRef(_0RL_c);
          _0RL_c.RequestCompleted();
          if (CORBA::is_nil(obj)) {
            if (omniORB::traceLevel > 10) {
              omniORB::log << "Received GIOP::LOCATION_FORWARD message that contains a nil object reference.\n";
              omniORB::log.flush();
            }
            throw CORBA::COMM_FAILURE(0,CORBA::COMPLETED_NO);
          }
          omniRopeAndKey _0RL__r;
          obj->PR_getobj()->getRopeAndKey(_0RL__r);
          oimpl->setRopeAndKey(_0RL__r);
        }
        if (omniORB::traceLevel > 10) {
          omniORB::log << "GIOP::LOCATION_FORWARD: retry request.\n";
          omniORB::log.flush();
        }
        break;
      }
    }
  }
  catch (const CORBA::COMM_FAILURE& ex) {
    if (_0RL_reuse || _0RL_fwd) {
      if (_0RL_fwd)
        oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callCommFailureExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::TRANSIENT& ex) {
    if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (const CORBA::OBJECT_NOT_EXIST& ex) {
    if (_0RL_fwd) {
      oimpl->resetRopeAndKey();
      CORBA::TRANSIENT _0RL_ex2(ex.minor(),ex.completed());
      if (!_omni_callTransientExceptionHandler(oimpl,_0RL_retries++,_0RL_ex2))
        throw _0RL_ex2;
    }
    else {
      if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
        throw;
    }
  }
  catch (const CORBA::SystemException& ex) {
    if (!_omni_callSystemExceptionHandler(oimpl,_0RL_retries++,ex))
      throw;
  }
  catch (...) {
    throw;
  }
#ifndef EGCS_WORKAROUND
  goto _0RL_again;
#else
}
#endif
}

class OMNIORB_EC_DII_Factory : public EC_DII_Factory {
  virtual EC_DII * create_ec_dii( CORBA::Object_ptr obj,
				  ECHelper::TypedInterface &_ti ) {
    return new OORB_DII( obj, _ti);
  }

  virtual void marshal( McastSource &src,
			ECMcast::Data &data) {
    MemBufferedStream mbs;
    MemBufferedStream dst;

    // Store the byte order of the marshalling machine
    CORBA::Char bo= (CORBA::Char) omni::myByteOrder;
    bo >>= mbs;
    bo >>= dst;

    CORBA::ULong tmp0= 0;
    tmp0 >>= mbs;
    CORBA::ULong l1= mbs.alreadyWritten();
    data >>= mbs;
    CORBA::ULong len= mbs.alreadyWritten()-l1;
    len >>= dst;
    dst.put_char_array( (_CORBA_Char*) (omni::ptr_arith_t) mbs.data() +
			(omni::ptr_arith_t) l1, 
			len);
    src.write( dst.data(), dst.alreadyWritten());
  }

  virtual void unmarshal( McastSink &sink,
			  ECMcast::Data &data) {
    ECMcast::Data dt;
    CORBA::Octet buf[8];
    sink.read( buf, 8);
    CORBA::Char byte_order= (CORBA::Char) buf[0];
    MemBufferedStream mbs;
    mbs.byteOrder( byte_order);
    mbs.put_char_array( buf, 8);
    byte_order <<= mbs;
    CORBA::ULong len;
    len <<= mbs;
    CORBA::Octet *allbuf= new CORBA::Octet[len];
    try {
      sink.read( allbuf, len);
      mbs.put_char_array( allbuf, len);
    }
    catch (...) {
      delete []allbuf;
      throw;
    }
    delete []allbuf;
    dt <<= mbs;
    data= dt;
  }
};

EC_DII_Factory *default_ec_dii_factory= new OMNIORB_EC_DII_Factory();

#endif

//
