// $Source: /home/iris/mencnar/ec/CVS/src/cc/pullcons.cc,v $
//
// $Id: pullcons.cc,v 1.1 1999/02/24 13:01:59 mencnar Exp $
//
// $Log: pullcons.cc,v $
// Revision 1.1  1999/02/24 13:01:59  mencnar
// *** empty log message ***
//
//

#include <iostream.h>
#include <stdlib.h>
#include "CosEventChannelAdmin.hh"
#include "CosTypedEventChannelAdmin.hh"
#include "TestIntf.hh"
#include "bootstrap.hh"
#include "compatibility.hh"
#include <omnithread.h>

class PullConsumer_I : public BOA_IMPL_BASE(CosEventComm,PullConsumer) 
{
  void disconnect_pull_consumer( ENV_DECL1(env)) {
    cerr << "PullConsumer disconnected, exitting..." << endl;
    exit(0);
  }  
};


CosTypedEventChannelAdmin::TypedProxyPullSupplier_var ptypedpullsupp;

void impl_is_ready( void *) {
  IMPL_IS_READY(Bootstrap::boa_ptr);
}

void pull_thread( void *par) {
  int index= (int) par;

  CORBA::Double d;
  CORBA::Boolean b;
  PullTestIntf_var pti;
  try {
    CORBA::Object_var obj= ptypedpullsupp->get_typed_supplier();
    pti= PullTestIntf::_narrow(obj);
  }
  catch (...) {
    cerr << "Failed to get typed pull supplier" << endl;
    exit(1);
  }

  switch (index) {
  case 0:
    for (;;) {
      CORBA::Any_var v;
      v= ptypedpullsupp->pull();
      try {
	char *s= NULL;
#ifdef OMNIORB
	CORBA::Any::to_string ts(s,0);
	v >>= ts;
#elif defined(ORBIX)
	v >>= s;
#endif
	cerr << s;
#ifdef OMNIORB
	if (s) CORBA::string_free(s);
#endif
      }
      catch (...) {
	exit(1);
      }  
    }
    break;
  case 1:
    for (;;) {
      try {
	pti->pull_operBoolean( b,d);
	cerr << "pull_operBoolean " 
	     << (int) b << ' ' << (double) d << endl;
      }
      catch (...) {
	exit(1);
      }
    }
    break;
  case 2:
    for (;;) {
      try {
	pti->pull_operDouble( d,b);
	cerr << "pull_operDouble " 
	     << (double) d << ' ' << (int) b << endl;
      }
      catch (...) {
	exit(1);
      }
    }
    break;
  case 3:
    for (;;) {
      try {
	CORBA::String_var s;
	pti->pull_operString( s);
	cerr << "pull_operString " 
	     << (const char *) s <<  endl;
      }
      catch (...) {
	exit(1);
      }
    }
    break;
  case 4:
    for (;;) {
      try {
	CORBA::Any_var a;
	pti->pull_operAny( a);
	cerr << "pull_operAny " << endl;
      }
      catch (...) {
	exit(1);
      }
    }
    break;
  }
}

void usage( const char *prog_name) {
  cerr << prog_name << " event_channel_name_in_NameServer [typed]" << endl;
  exit(1);
}

int main(int argc, char **argv) {
  Bootstrap::init(argc,argv);
  if (argc!=2 && argc!=3) usage(argv[0]);
  
  if (argc==2) {
    CosEventChannelAdmin::EventChannel_var ec;
    
    CosNaming::NamingContext_var nsroot= Bootstrap::getNS();
    try {
      ec= CosEventChannelAdmin::EventChannel::_narrow(
		    nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Event Channel" << endl;
      return 1;
    }
    cerr << "Found EC" << endl;
    
    CosEventChannelAdmin::ProxyPullSupplier_var ppullsupp;
    try {
      CosEventChannelAdmin::ConsumerAdmin_var ca=
	ec->for_consumers();
      cerr << "for_consumers" << endl;
      ppullsupp= ca->obtain_pull_supplier();
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ppullsupp)) {
      cerr << "Could not obtain ProxyPullSupplier from EventChannel" << endl;
      return 1;
    }
    
    PullConsumer_I &pullconsi= *(new PullConsumer_I());
    CONNECT_IMPL(Bootstrap::boa_ptr,&pullconsi);
    try {
      ppullsupp->connect_pull_consumer( &pullconsi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a pull consumer" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;
    (new omni_thread( impl_is_ready, NULL))->start();
    
    for (;;) {
      try {
      CORBA::Any_var v;
      cerr << "pull: ";
      v= ppullsupp->pull();
      cerr << "ok";
      try {
	char *s= NULL;
#ifdef OMNIORB
	CORBA::Any::to_string ts(s,0);
	v >>= ts;
#elif defined(ORBIX)
	v >>= s;
#endif
	cerr << s;
#ifdef OMNIORB
	if (s) CORBA::string_free(s);
#endif
      }
      catch (...) {
      }  
      cerr << endl; 
      }
      catch (CosEventComm::Disconnected &) {
	cerr << "Disconnected" << endl;
	break;
      }
      catch (CORBA::Exception &ex) {
	cerr << ex << endl;
	cerr << "Failed to pull data from Event Channel" << endl;
	break;
      }
    }
  }
  else {
    CosTypedEventChannelAdmin::TypedEventChannel_var ec;
    
    CosNaming::NamingContext_var nsroot= Bootstrap::getNS();
    try {
      ec= CosTypedEventChannelAdmin::TypedEventChannel::_narrow(
		    nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Event Channel" << endl;
      return 1;
    }
    cerr << "Found EC" << endl;
    
    try {
      CosTypedEventChannelAdmin::TypedConsumerAdmin_var ca=
	ec->for_consumers();
      cerr << "for_consumers" << endl;
      ptypedpullsupp= ca->obtain_typed_pull_supplier( "");
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ptypedpullsupp)) {
      cerr << "Could not obtain ProxyPullSupplier from EventChannel" << endl;
      return 1;
    }
    
    PullConsumer_I &pullconsi= *(new PullConsumer_I());
    CONNECT_IMPL(Bootstrap::boa_ptr,&pullconsi);
    try {
      ptypedpullsupp->connect_pull_consumer( &pullconsi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a push supplier" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;

    for (int i=0; i<4; i++)
      (new omni_thread( pull_thread, (void*) i))->start();
  }
}



