// $Id: pullsupp.cc,v 1.2 1999/02/24 12:57:10 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/pullsupp.cc,v $
//
// $Log: pullsupp.cc,v $
// Revision 1.2  1999/02/24 12:57:10  mencnar
// *** empty log message ***
//
//

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "CosEventChannelAdmin.hh"
#include "CosTypedEventChannelAdmin.hh"
#include "TestIntf.hh"
#include "bootstrap.hh"
#include <omnithread.h>
#include "compatibility.hh"

void deact( void *) {
  omni_thread::sleep(1,0);
  cerr << "deactivate impl" << endl;
#ifdef OMNIORB
  Bootstrap::boa_ptr->impl_shutdown();
#else
  Bootstrap::boa_ptr->deactivate_impl(NULL);
#endif
}

void impl_is_ready( void *) {
  IMPL_IS_READY(Bootstrap::boa_ptr);
}

omni_mutex guard;
omni_condition wait_cond(&guard);
char buf[100];

class PullSupplier_I : public BOA_IMPL_BASE(CosEventComm,PullSupplier) 
{
 public:
  void disconnect_pull_supplier( ENV_DECL1(env)) {
    cerr << "PullSupplier disconnected, exitting..." << endl;
    exit(0);
  }

  CORBA::Any *pull( ENV_DECL1(env)) {
    cerr << "pull: ";
    char buf[1024];
    if (cin >> buf) {
      CORBA::Any *v= new CORBA::Any();
#ifdef OMNIORB
      CORBA::Any::from_string fs(buf, 0);
      (*v) <<= fs;
#elif defined(ORBIX)
      (*v) <<= buf;
#endif
      return v;
    }
    else {
      (new omni_thread(deact,NULL))->start();
      throw CosEventComm::Disconnected();
      return NULL; // dummy return, never reached
    }
  }

  CORBA::Any *try_pull( CORBA::Boolean &has_event
			ENV_DECL(env)) {
    has_event= 0;
    return new CORBA::Any();
  }
};

class PullTestIntf_I
  : public BOA_IMPL_BASE1(PullTestIntf) 
{
 public:
  void pull_operBoolean( CORBA::Boolean &b, 
			 CORBA::Double &d
			 ENV_DECL(env)) {
    cerr << "pull_operBoolean" << endl;
    omni_mutex_lock oml(guard);
    while (buf[0] != '1')
      wait_cond.wait();
    int _b;
    double _d;
    if (sscanf(buf+1, "%i%lf", &_b, &_d) == 2) {
      b= _b;
      d= _d;
    }
    buf[0]= '#';
  }

  CORBA::Boolean try_operBoolean( CORBA::Boolean &b, 
				  CORBA::Double &d
				  ENV_DECL(env)) {
    return 0;
  }
  //--------------------------------------------------------------------
  void pull_operDouble( CORBA::Double &d, 
			CORBA::Boolean &b
			ENV_DECL(env)) {
    cerr << "pull_operDouble" << endl;
    omni_mutex_lock oml(guard);
    while (buf[0] != '2')
      wait_cond.wait();
    int _b;
    double _d;
    if (sscanf(buf+1, "%lf%d", &_d, &_b) == 2) {
      b= _b;
      d= _d;
    }
    buf[0]= '#';
  }

  CORBA::Boolean try_operDouble( CORBA::Double &d, 
				 CORBA::Boolean &b
				 ENV_DECL(env)) {
    return 0;
  }
  //--------------------------------------------------------------------
  void pull_operString( char * &s
			ENV_DECL(env)) {
    cerr << "pull_operString" << endl;
    omni_mutex_lock oml(guard);
    while (buf[0] != '3')
      wait_cond.wait();
    s= CORBA::string_dup(buf+1);
    buf[0]= '#';
  }
  CORBA::Boolean try_operString( char * &s
				 ENV_DECL(env)) {
    return 0;
  }

  //--------------------------------------------------------------------
  void pull_operAny( CORBA::Any * &a
		     ENV_DECL(env)) {
    cerr << "pull_operAny" << endl;
    omni_mutex_lock oml(guard);
    while (buf[0] != '4')
      wait_cond.wait();
    a= new CORBA::Any();
    (*a) <<= (CORBA::Double) 3.14159;
    buf[0]= '#';    
  }
  CORBA::Boolean try_operAny( CORBA::Any * &s
			      ENV_DECL(env)) {
    return 0;
  }

  void pull_operPerf( PerfTests *&a
		      ENV_DECL(env)) {
    a= new PerfTests(0);
  }

  CORBA::Boolean try_operPerf( PerfTests *&a
			       ENV_DECL(env)) {
    return 0;
  }
};

class TypedPullSupplier_I 
  : public BOA_IMPL_BASE(CosTypedEventComm,TypedPullSupplier) 
{
  PullTestIntf_I &ptti;
 public:
  TypedPullSupplier_I( PullTestIntf_I &_ptti) :
    ptti( _ptti) {}

  void disconnect_pull_supplier( ENV_DECL1(env)) {
    cerr << "TypedPullSupplier disconnected, exitting..." << endl;
    exit(0);
  }

  CORBA::Any *pull( ENV_DECL1(env)) {
    cerr << "pull: " << endl;
    omni_mutex_lock oml(guard);
    while (buf[0] != '0')
      wait_cond.wait();
    CORBA::Any *v= new CORBA::Any();
#ifdef OMNIORB
    CORBA::Any::from_string fs(buf, 0);
    (*v) <<= fs;
#elif defined(ORBIX)
    (*v) <<= buf;
#endif
    buf[0]= '#';
    return v;
  }

  CORBA::Any *try_pull( CORBA::Boolean &has_event
			ENV_DECL(env)) {
    has_event= 0;
    return new CORBA::Any();
  }

  CORBA::Object_ptr get_typed_supplier( ENV_DECL1(env)) {
    return PullTestIntf::_duplicate( &ptti);
  }
};

void usage( const char *prog_name) {
  cerr << prog_name << " event_channel_name_in_NameServer [typed]" << endl;
  exit(1);
}

int main(int argc, char **argv) {
  Bootstrap::init(argc,argv);
  if (argc!=2 && argc!=3) usage(argv[0]);

  if (argc==2) {
    CosEventChannelAdmin::EventChannel_var ec;
    
    CosNaming::NamingContext_var nsroot= Bootstrap::getNS();
    try {
      ec= CosEventChannelAdmin::EventChannel::_narrow(
	       nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Event Channel" << endl;
      return 1;
    }
    CosEventChannelAdmin::ProxyPullConsumer_var ppullcons;
    try {
      CosEventChannelAdmin::SupplierAdmin_var sa=
	ec->for_suppliers();
      cerr << "for_suppliers" << endl;
      ppullcons= sa->obtain_pull_consumer();
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ppullcons)) {
      cerr << "Could not obtain ProxyPullConsumer from EventChannel" << endl;
      return 1;
    }

    PullSupplier_I &pullsupi= *(new PullSupplier_I());
    CONNECT_IMPL(Bootstrap::boa_ptr,&pullsupi);
    try {
      ppullcons->connect_pull_supplier( &pullsupi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a pull consumer" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;
    Bootstrap::boa_ptr->impl_is_ready();
    cerr << "Implementation finished" << endl;
    Bootstrap::boa_ptr->dispose(&pullsupi);
  }
  else {

    CosTypedEventChannelAdmin::TypedEventChannel_var ec;
    
    CosNaming::NamingContext_var nsroot= Bootstrap::getNS();
    try {
      ec= CosTypedEventChannelAdmin::TypedEventChannel::_narrow(
	       nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Typed Event Channel" << endl;
      return 1;
    }
    CosEventChannelAdmin::ProxyPullConsumer_var ppullcons;
    try {
      CosTypedEventChannelAdmin::TypedSupplierAdmin_var sa=
	ec->for_suppliers();
      cerr << "for_suppliers" << endl;
      ppullcons= sa->obtain_typed_pull_consumer( "");
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ppullcons)) {
      cerr << "Could not obtain ProxyPullConsumer from EventChannel" << endl;
      return 1;
    }

    PullTestIntf_I ptti;

    TypedPullSupplier_I &pullsupi= *(new TypedPullSupplier_I(ptti));
    CONNECT_IMPL(Bootstrap::boa_ptr,&pullsupi);
    try {
      ppullcons->connect_pull_supplier( &pullsupi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a pull consumer" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;
    Bootstrap::boa_ptr->impl_is_ready();
    cerr << "Implementation finished" << endl;
    Bootstrap::boa_ptr->dispose(&pullsupi);
  }
  return 0;
}

