#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <ifr.hh>
#include <IT_ifr.hh>
#include "bootstrap.hh"

int main( int argc, char **argv) {
  Bootstrap::init(argc,argv);

  CORBA::Orbix.setDiagnostics( 0);
  CORBA::Object_var obj= 
    CORBA::Orbix.resolve_initial_references("InterfaceRepository");
  Repository_var rep= 
    Repository::_narrow(obj);
  CORBA::String_var s= rep->_object_to_string();
  cerr << "IFR resolved" << endl;
  cout << (const char *) s << endl;

  CosNaming::NamingContext_var nsroot= Bootstrap::getNS(0);
  if (!CORBA::is_nil(nsroot)) {
    CosNaming::Name name= Bootstrap::SRV_IR();
    try {
      nsroot->unbind(name);
    }
    catch (...) {}

    try {
      nsroot->bind(name,rep);
    }
    catch (...) {
      cerr << "Unable to register IFR reference in NameService" << endl;
      return 1;
    }
  }
  else cerr << "Null nsroot" << endl;
  return 0;
}



