
#ifndef __UNIQUE_IDS_HH__
#define __UNIQUE_IDS_HH__

#include "locks.hh"

template
<class T>
class UniqueID {
  T r;
  omni_mutex guard;
public:
  UniqueID(T init_r) : r( init_r) {}

  T assign_id() {
    omni_mutex_lock oml(guard);
    return ++r;
  }
};

#endif // __UNIQUE_IDS_HH__

//
